"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Create = void 0;
const api_typed_1 = require("api-typed");
const lodash_snakecase_1 = __importDefault(require("lodash.snakecase"));
const mkdirp_1 = __importDefault(require("mkdirp"));
const typedi_1 = require("typedi");
const TemplateProcessor_1 = require("../features/Templating/TemplateProcessor");
const TEMPLATES = ['standard'];
let Create = class Create {
    constructor(templateProcessor, logger) {
        this.templateProcessor = templateProcessor;
        this.logger = logger;
    }
    async run(appName, { template }) {
        this.logger.info(`Creating Api-Typed app "${appName}" from ${template} template...`);
        const projectDir = await this.prepareDir(appName);
        this.logger.debug(`Created dir "${projectDir}"`);
        const params = {
            appName,
            snakeCaseName: lodash_snakecase_1.default(appName),
            kabebCaseName: lodash_snakecase_1.default(appName).replace('_', '-'),
            packageName: lodash_snakecase_1.default(appName).replace('_', '-'),
        };
        await this.templateProcessor.install(['shared', template], projectDir, params);
    }
    async prepareDir(appName) {
        const dirName = appName;
        if (api_typed_1.isDir(dirName)) {
            throw new Error(`Directory "./${appName}" already exists.`);
        }
        const result = await mkdirp_1.default(dirName);
        return result;
    }
};
Create = __decorate([
    api_typed_1.Command('create <name>', {
        template: {
            short: 't',
            value: 'required',
            description: 'Template to use.',
            default: 'standard',
            choices: TEMPLATES,
        },
    }),
    typedi_1.Service(),
    __param(0, typedi_1.Inject(() => TemplateProcessor_1.TemplateProcessor)),
    __param(1, api_typed_1.InjectLogger()),
    __metadata("design:paramtypes", [TemplateProcessor_1.TemplateProcessor, Object])
], Create);
exports.Create = Create;
//# sourceMappingURL=Create.js.map