"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractTemplate = void 0;
const glob_1 = __importDefault(require("glob"));
const path_1 = __importDefault(require("path"));
class AbstractTemplate {
    getFiles() {
        const templateDirRegExp = new RegExp(`^${this.templateDir}/`);
        const templateFiles = glob_1.default
            .sync(`${this.templateDir}/**/*`, {
            nodir: true,
            dot: true,
        })
            .map((srcPath) => {
            return {
                srcPath,
                fileName: path_1.default.basename(srcPath),
                projectPath: srcPath
                    .replace(templateDirRegExp, '')
                    .replace(/\.hbs$/, ''),
                isTemplate: srcPath.endsWith('.hbs'),
            };
        });
        return templateFiles;
    }
    getPackages() {
        return [];
    }
    getDevPackages() {
        return [];
    }
}
exports.AbstractTemplate = AbstractTemplate;
//# sourceMappingURL=AbstractTemplate.js.map